// hotkey.cpp : hotkeys for winamp

#define WIN32_LEAN_AND_MEAN
#include <windows.h>

// this removes the C runtime overhead
void WinMainCRTStartup()
{
  WinMain(0,0,0,0);
  ExitProcess(0);
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
  // start only once
  HANDLE hMutex = CreateMutex(NULL, TRUE, "WinampHotkeyRunning_Mutex");
  if (GetLastError() == ERROR_ALREADY_EXISTS)
    return 1;

  RegisterHotKey(NULL, 1, MOD_WIN, VK_ESCAPE); // quit hotkey

  RegisterHotKey(NULL, 44, MOD_CONTROL | MOD_WIN, VK_LEFT);  // prev
  RegisterHotKey(NULL, 48, MOD_CONTROL | MOD_WIN, VK_RIGHT); // next
  RegisterHotKey(NULL, 58, MOD_WIN, VK_UP);    // vol up
  RegisterHotKey(NULL, 59, MOD_WIN, VK_DOWN);  // vol down

  RegisterHotKey(NULL, 144, MOD_WIN, VK_LEFT);  // rewind 5 sec
  RegisterHotKey(NULL, 148, MOD_WIN, VK_RIGHT); // fwd 5 sec

  RegisterHotKey(NULL,  45, MOD_WIN, VK_INSERT);  // play
  RegisterHotKey(NULL,  46, MOD_WIN, VK_HOME); // pause
  RegisterHotKey(NULL,  47, MOD_WIN, VK_END); // stop

  RegisterHotKey(NULL,  64, MOD_WIN, VK_PRIOR);  // windowshade
  RegisterHotKey(NULL, 266, MOD_WIN, VK_NEXT); // pl windowshade

  MSG msg;
  while (GetMessage(&msg, NULL, 0, 0)) {
    if (msg.message == WM_HOTKEY) {
      if (msg.wParam == 1)
        break;   // quit
      HWND hwndWinamp = FindWindow("Winamp v1.x",NULL);
      if (hwndWinamp)
        SendMessage(hwndWinamp, WM_COMMAND, 40000+msg.wParam, 0);
    }
  }

  return 0;
}
